

Program apimatrix;

uses
  Windows,
  Messages,
  SysUtils,
  Graphics;

type TRect = record
  Left, Top, Right, Bottom: Integer;
end;

type
  TVertice=Record
    x,y,z:single;
end;

type
  TPolygon=Record
    typ:integer; //Type 0=Grafik 1=Rahmen Polygon fr Kollisionscheck
    color: TColor; //Farbe des Polygons
    Texture: integer; //Tapetenoffset
    collision:bool;    //Collisionsprfung bei Polygon?
    DrawCou:integer; //Anzahl Vertices des Polygons
    Draw: array of integer; //Offsets der Vertices
end;

type
  TObjekt=RECORD
    text: array [0..20] of char;
    typ:byte;                 //Type des Objekts (wird nicht verwendet)
    VertCount: integer;       //Anzahl Vertices im Objekt
    vert:array of TVertice;   //diverse Vertices
    PolyCou:integer;          //Anzahl Polygone im Objekt
    poly:array of TPolygon;   //Polygonzeiger
end;

type
  TStatic=Record     //Statisches Objekt
    dx,dy,dz:single;
    umx,umy,umz:single;
    ob:integer;      //zugewiesenes Objekt
end;

type
  TQuadrant=RECORD
    co:integer; //Anzahl Objekte im Quadranten
    st:array of TStatic; //Zeiger auf diverse Objekte in dem Quadranten
end;

type
  TActor=Record
    x,y,z:single;	   //Position in der Welt
    qx,qy,qz:single; //Position im Quadranten
    umx,umy,umz:single;    //Letzte Winkel (Winkel um X-Achse ...)
    lx,ly,lz:single;	   //Letzte Position (last x, last y ...)
    lumx,lumy,lumz:single; //Letzte Winkel (last Winkel um X ...)
    ob:integer;		   //Objekt Offset (Welches Objekt verwendet der Actor)
    sp:single;  	   //Speed des Actors
    quadrant:integer; //In welchem Quadranten steckt der Actor gerade?
end;

Type
  TLines=Record
    Obj:integer;		   //auf Kollision zu prfende Linie gehrt zu welchem Objekt?
    Typ:integer;       //welcher Typ hat diese Linie
    x1,y1,x2,y2:single;	   //2D-Koordinaten der Linie, die auf Kollision geprft werden soll
end;

Type
  TKollisionsLinien=Record
    LineCou:integer;
    Lines: array of TLines;
end;

const
  AppName = 'API';	   //Application-Name
  pi=3.1428;		   //Konstante fr Ausrechnung Bogenmass des Winkels

var
  //Allgemeine System Verwaltung
  AMessage:TMsg;			//Systemmessage Struktur/Record
  HWindow:HWND;				//Handle auf das Window
  WindowClass:TWndClass; 		//neue Fensterklasse im System
  taste: array [0..255] of bool;	//Feld mit gedrckten Tastaturwerten
  lastkey: integer;			//Welche Taste war die letze - dient nur der Anzeige
  running: bool = true; 		//Solange running=true -> Programm aktiv
  sysmes: bool; 			//Ergebnis von GetMessage Funktion am Ende des Prgs.
  dc: HDC; 				//Gertekontext Fenster
  canvas: TCanvas;			//Standard Grafikplattform
  //Frames per Second Verwaltung
  ifps:integer;				//Momentan F/s
  lastfps:integer;			//letzter F/S Wert - Grundlage fr Syncronisation
  itimold,itimnew,itimdel:integer;	//Hilfsvariablen F/S
  
  //Fenster und Bitmaps
  bg:TBitmap;				//Bitmap, in der gezeichnet wird
  myRect:Windows.TRect;			//fr Grsse der Bitmap in Pixel
  winheight,winwidth:integer;		//fr def. Grsse des Windows

  qua: array of TQuadrant;	//Matrix Array stellt die Quadranten der Welt dar
  obj: array of TObjekt;	//Objekt Array enthlt die diversen Objekte in einem Quadranten
  act: array of TActor;		//Actor (Objekt, da durch den Anwender gesteuert wird) Array
  slin: array of TKollisionsLinien;
  alin: array of TKollisionsLinien;
  Actors:integer; //Wieviele Acteure gibt es
  Xsize,Ysize,Welt:integer;		//Die Welt besteht aus wieviel Quadranten in X-Richtung/horizontal
  xori,yori,zori:single;	//Origin X,Y,Z - wo ist der Mittelpunkt des Bildschirms?
  ac,qc,oc:integer; 		//Offset Actor , Objekt-Offset
  x,y,z:single; 		//Rotations-Procedure Incoming and Outgoing
  ux,uy,uz:single ; 		//Rotationswerte in Rotationsprocedure
  alpha,beta,gamma:single; 	//Bogenmass Winkel eines gesamten Objekts (nur Actor)
  bShowCLines:boolean; //Sollen die Kollisionslinien gezeigt werden

  //Variablen Kollisionsprfung
  stalincou,actlincou,StaLines,ActLines:integer; 	//Zhler gespeicherter Kollisions-Prf-Linien, MAx. Anzahl Kollisionslinien
  kreuzpunkt_ab:single;  	//Kreuzp. Streck A nach B
  kreuzpunkt_cd:single;  	//Kreuzp. Streck B nach C
  kreuzpunkt_x:single;   	//Koordinate Treffpunkt X
  kreuzpunkt_y:single;   	//Koordinate Treffpunkt Y

//--------------------------------------
//bentigte Proceduren und Funktionen...
//--------------------------------------

//Werte setzen
procedure setzevars;
var
  la,lq:integer; //Loop Actors
begin
  //Allgemein (Screen)
  winwidth:=640;
  winheight:=400;
  myRect.left:=2;
  myRect.top:=26;
  myRect.right:=winwidth-2;
  myRect.bottom:=winheight-2;
  xori:=trunc(winwidth/2);	//Wo ist der X Mittelpunkt des Fensters
  yori:=trunc(winheight/2);	//Wo ist der y Mittelpunkt des Fensters
  //Timing
  ifps:=0;
  itimnew:=gettickcount;
  itimold:=itimnew;
  //Kollisionslinien Feld lin
  bShowCLines:=true;

  //Welt
  XSize:=10; 			//Welt bestetht aus 1*n Quadranten
  YSize:=10;
  Welt:=XSize*YSize;
  SetLength(qua,Welt);        //100 Quadranten sollen erst mal in der Welt (Matrix) reichen
  SetLength(Obj,100);  		  //100 Objekte insgesamt tuns auch
  //
  Actors:=2;

  //Rahmendaten der Actoren
    SetLength(act,actors);		//Array fr n Acteure dimensioniert
    ac:=0;			//Offset des einzigen Actors
    act[ac].x:=250;		//Position in der Welt <X>
    act[ac].y:=250;		//Position in der Welt <Y>
    act[ac].umz:=180;		//Drehwinkel um Z Achse (Vogelperspektive, 2D Scenario)
    act[ac].ob:=1;  		//Offset Objekt (gleich dreieckiges Objekt)
    act[ac].sp:=0.2;  		//Anfangsspeed
    act[ac].quadrant:=51;  //Start im Quadranten 0

    SetLength(act,actors);		//Array fr n Acteure dimensioniert
    ac:=1;			//Offset des einzigen Actors
    act[ac].x:=280;		//Position in der Welt <X>
    act[ac].y:=300;		//Position in der Welt <Y>
    act[ac].umz:=155;		//Drehwinkel um Z Achse (Vogelperspektive, 2D Scenario)
    act[ac].ob:=1;  		//Offset Objekt (gleich dreieckiges Objekt)
    act[ac].sp:=0.05;		//Anfangsspeed
    act[ac].quadrant:=51;  //Start im Quadranten 0

    ac:=0;            //Main Actor fr Steuerung

  //Kollisionslinien der statischen Objekte initlialisieren
    SetLength(aLin,actors);
    for la:=0 to actors-1 do
    begin
      SetLength(alin[la].Lines,100); //Platz fr 0...99 Kollisionslinien
    end;
    SetLength(sLin,Welt);
    for lq:=0 to Welt-1 do
    begin
      SetLength(slin[lq].Lines,20); //Platz fr 0...99 Kollisionslinien
    end;

  //----------------------------------------------
  //HINDERNISS Objekt definieren (Quadrat)
  //----------------------------------------------
    oc:=0;
    Obj[0].text:='Quader'+#0;
    Obj[0].Typ:=1; 		    //Type 1=Hinderniss (wird nicht weiter abgefragt, da Kollisionsschalter auch im einzelnen Polygon)
    Obj[0].VertCount:=4;                     //4 Vertices hat dieses Objekt 0
    SetLength(Obj[0].Vert,Obj[0].VertCount); //Dimensionierung Array Vert
    Obj[0].Vert[0].x:=-10;                    //Vertice 1
    Obj[0].Vert[0].y:=-10;
    Obj[0].Vert[0].z:=0;
    Obj[0].Vert[1].x:=+10;                    //Vertice 2
    Obj[0].Vert[1].y:=-10;
    Obj[0].Vert[1].z:=0;
    Obj[0].Vert[2].x:=+10;                    //Vertice 3
    Obj[0].Vert[2].y:=+10;
    Obj[0].Vert[2].z:=0;
    Obj[0].Vert[3].x:=-10;                    //Vertice 4
    Obj[0].Vert[3].y:=+10;
    Obj[0].Vert[3].z:=0;

    Obj[0].PolyCou:=2; 		//Anzahl Polygone im Objekt
    SetLength(Obj[0].Poly,Obj[0].PolyCou);	//Dimensionierung Feld der Polygone des Objekts 0
    //Polygon 0 im Objekt 0
      Obj[0].poly[0].typ:=0; //0=Rahmenpolygon zwecks Kollisionsprfung
      Obj[0].poly[0].color:=rgb(255,10,10);
      Obj[0].poly[0].Texture:=0;
      Obj[0].poly[0].collision:=true;
      Obj[0].poly[0].DrawCou:=5;
      SetLength(Obj[0].poly[0].Draw,Obj[0].poly[0].DrawCou);
      Obj[0].poly[0].draw[0]:=0;
      Obj[0].poly[0].draw[1]:=1;
      Obj[0].poly[0].draw[2]:=2;
      Obj[0].poly[0].draw[3]:=3;
      Obj[0].poly[0].draw[4]:=0;
    //Polygon 1 im Objekt 0
      Obj[0].poly[1].typ:=9; //Grafikpolygon, dass nicht der Kollisionsprfung dient
      Obj[0].poly[1].color:=rgb(255,10,10);
      Obj[0].poly[1].Texture:=0;
      Obj[0].poly[1].collision:=false;
      Obj[0].poly[1].DrawCou:=5;
      SetLength(Obj[0].poly[1].Draw,Obj[0].poly[1].DrawCou);
      Obj[0].poly[1].draw[0]:=0;
      Obj[0].poly[1].draw[1]:=1;
      Obj[0].poly[1].draw[2]:=2;
      Obj[0].poly[1].draw[3]:=3;
      Obj[0].poly[1].draw[4]:=0;

  //----------------------------------------------
  //Quadrantbegrenzung Objekt definieren (2 Linien / halbes Kreuz)
  //----------------------------------------------
    oc:=2;
    Obj[2].text:='Border'+#0;
    Obj[2].Typ:=2; 		    //ObjektType 2 = GFX, nicht auf Kollision prfen
    Obj[2].VertCount:=3;                     //3 Vertices hat dieses Objekt 2
    SetLength(Obj[2].Vert,Obj[2].VertCount); //Dimensionierung Array Vert
    Obj[2].Vert[0].x:=0;                    //Vertice 1
    Obj[2].Vert[0].y:=0;
    Obj[2].Vert[0].z:=0;
    Obj[2].Vert[1].x:=0;                    //Vertice 2
    Obj[2].Vert[1].y:=499;
    Obj[2].Vert[1].z:=0;
    Obj[2].Vert[2].x:=499;                    //Vertice 3
    Obj[2].Vert[2].y:=499;
    Obj[2].Vert[2].z:=0;

    Obj[2].PolyCou:=1; 		//Anzahl Polygone im Objekt
    SetLength(Obj[2].Poly,Obj[2].PolyCou);	//Dimensionierung Feld der Polygone des Objekts 0
    //Polygon 0 im Objekt 2
      Obj[2].poly[0].typ:=9; //Grafikpolygon, dass nicht der Kollisionsprfung dient
      Obj[2].poly[0].color:=rgb(60,60,60);
      Obj[2].poly[0].Texture:=0;
      Obj[2].poly[0].collision:=false;
      Obj[2].poly[0].DrawCou:=3;
      SetLength(Obj[2].poly[0].Draw,Obj[2].poly[0].DrawCou);
      Obj[2].poly[0].draw[0]:=0;
      Obj[2].poly[0].draw[1]:=1;
      Obj[2].poly[0].draw[2]:=2;

  //----------------------------------------------
  //FAHRZEUG Objekt definieren (Dreieck)
  //----------------------------------------------
    oc:=1;
    Obj[1].text:='Triangle'+#0;
    Obj[1].Typ:=0; 		    //Type 0 = Actor
    Obj[1].VertCount:=3;                     //3 Vertices hat dieses Objekt 1
    SetLength(Obj[1].Vert,Obj[1].VertCount); //Dimensionierung Array Vert
    Obj[1].Vert[0].x:=-10;                    //Vertice 1
    Obj[1].Vert[0].y:=-10;
    Obj[1].Vert[0].z:=0;
    Obj[1].Vert[1].x:=+10;                  //Vertice 2
    Obj[1].Vert[1].y:=-10;
    Obj[1].Vert[1].z:=0;
    Obj[1].Vert[2].x:=0;                  //Vertice 3
    Obj[1].Vert[2].y:=+10;
    Obj[1].Vert[2].z:=0;

    Obj[1].PolyCou:=2; 		//Anzahl Polygone im Objekt
    SetLength(Obj[1].Poly,Obj[1].PolyCou);	//Dimensionierung Feld der Polygone des Objekts 1
    //Polygon 0 im Objekt 1
      Obj[1].poly[0].typ:=0; //0=Rahmenpolygon zwecks Kollisionsprfung
      Obj[1].poly[0].color:=rgb(0,255,0);
      Obj[1].poly[0].Texture:=0;
      Obj[1].poly[0].collision:=true;
      Obj[1].poly[0].DrawCou:=4;
      SetLength(Obj[1].poly[0].Draw,Obj[1].poly[0].DrawCou);
      Obj[1].poly[0].draw[0]:=0;
      Obj[1].poly[0].draw[1]:=1;
      Obj[1].poly[0].draw[2]:=2;
      Obj[1].poly[0].draw[3]:=0;
    //Polygon 1 im Objekt 0
      Obj[1].poly[1].typ:=9; //Grafikpolygon, dass nicht der Kollisionsprfung dient
      Obj[1].poly[1].color:=rgb(0,180,0);
      Obj[1].poly[1].Texture:=0;
      Obj[1].poly[1].collision:=false;
      Obj[1].poly[1].DrawCou:=4;
      SetLength(Obj[1].poly[1].Draw,Obj[1].poly[1].DrawCou);
      Obj[1].poly[1].draw[0]:=0;
      Obj[1].poly[1].draw[1]:=1;
      Obj[1].poly[1].draw[2]:=2;
      Obj[1].poly[1].draw[3]:=0;


  //Quadrant definieren (Matrix mit einzelnen Objekten bestcken)
  qc:=51;             //Welcher Quadrant?
  qua[qc].co:=4; 			//Anzahl zugewiesener Objekte im Quadranten qc
  SetLength(qua[qc].st,qua[qc].co);

  qua[qc].st[0].dx:=150;		//Wo ist das Objekt im Quadranten? (Delaywerte x,y,z)
  qua[qc].st[0].dy:=350;
  qua[qc].st[0].dz:=0;
  qua[qc].st[0].ob:=0; 			//an der Stelle soll Objekt 0 gesetzt werden
  qua[qc].st[0].umz:=0;      //gedreht?

  qua[qc].st[1].dx:=220;  		//noch ein Objekt weiter rechts im Quadranten 0
  qua[qc].st[1].dy:=230; 		//weiter unten
  qua[qc].st[1].dz:=0;
  qua[qc].st[1].ob:=0; 			//an dieser Stelle soll auch Objekt 0 gesetzt werden
  qua[qc].st[1].umz:=60;      //gedreht?

  qua[qc].st[2].dx:=310;			//noch ein Objekt 0 in dem Quadranten 0 setzen...
  qua[qc].st[2].dy:=370;
  qua[qc].st[2].dz:=0;
  qua[qc].st[2].ob:=0;
  qua[qc].st[2].umz:=75;      //gedreht?

  qua[qc].st[3].dx:=0;			//noch ein Objekt 0 in dem Quadranten 0 setzen...
  qua[qc].st[3].dy:=0;
  qua[qc].st[3].dz:=0;
  qua[qc].st[3].ob:=2;       //=Kreuz Quadrantengrenzlinien
  qua[qc].st[3].umz:=0;     //gedreht?

end;

//Bewegungswerte der Frames per Second Frequenz anpassen - je mehr Frams, desto kleiner der Bewegungswert
function sync(wert:single):single;
begin
  if lastfps=0 then exit;	//Keine Division durch Null zulassen
  result:=wert/lastfps;		//Ergebnis gleich Bewegungswert durch Anzahl Bilder pro Sekunde
end;

procedure tastatur;
begin
  if taste[vk_escape] then running:=false;		//Programmende durch ESC Taste
  if taste[vk_f1] then
  begin
    inc(ac);
    if ac=actors then ac:=0;
    taste[vk_f1]:=false;
  end;
end;

//Frames per Second besorgen
procedure zeitmessung;
begin
  inc(ifps);
  itimnew:=gettickcount;	//Millisekunden Zhler seit Systemstart
  itimdel:=itimnew-itimold;
  if itimdel>1000 then		//nach Sekunde Zhlergebnis merken...
  begin
    itimold:=itimnew;
    lastfps:=ifps;		//...in lastfps
    ifps:=0;
  end;
end;

//Etwas auf dem Schirm anzeigen
procedure screentext;
begin
  bg.canvas.textout(20,32,'<F1=Switch Actor> Taste='+inttostr(lastkey)+'   F/S='+inttostr(lastfps));
  bg.Canvas.TextOut(20,46,'ActorNo= '+inttostr(ac)+'  X='+inttostr(trunc(Act[ac].x))+'  Y='+inttostr(trunc(Act[ac].y))+'  Quadrant='+inttostr(Act[ac].quadrant));
end;

//Rotieren um Achsen
//bergeben werden
//	x,y,z (Punkt wird um 0,0,0 rotiert)
//	umx,umy,umz (Um welche Achse rotieren - Angabe in Grad)
// Ergebnis sind die neuen Koordinaten
//	nx,ny,nz
procedure Rotation;
var
  x1,y1,z1:single;
begin
  // Rotation um die x-Achse
  x1:=x;
  y1:=(y*cos(alpha)-z*sin(alpha));
  z1:=(y*sin(alpha)+z*cos(alpha));
  // Rotation um die Y-Achse
  x:=(x1*cos(beta)-z1*sin(beta));
  y:=y1;
  z:=(x1*sin(beta)+z1*cos(beta));
  // Rotation um die Z-Achse
  z1:=z;
  x1:=(x*cos(gamma)-y*sin(gamma));
  y1:=(x*sin(gamma)+y*cos(gamma));
  {//Datenumrechnung fr die 2D Darstellung (hier berflssig)
  //q:=trunc((x1+dx)*fac/(c1+zoom)+xori); //dx=Delaywert fac=Manipulationsfaktor zoom=Zoomwert xori=Windowmitte q=neuer 2D Wert X Achse
  //w:=trunc((y1+dy)*fac/(c1+zoom)+yori);}
  // Werte speichern
  x:=x1;
  y:=y1;
  z:=z1;
end;

//Objekte zeichen
procedure drawStatic;
var
  la,lm,lp,ld:integer;		//for "L"oop- ... Variablen
  quadrant:integer; 			//Matrix/Quadrantenoffset
  oof:integer;			//Offset eines Objekts
  odx,ody,odz:single;		//Delaywert eines Objekts (wo ist es in der Welt?)
  dtype:integer; //Drawtype Polygon Rahmen, Grafik ...
  vertice:integer; //Offset Vertice
  qmerk:string;
  Rotierung:bool;
  LastX,LastY:single;
  LinCou:integer;
begin
  //Zeichnen
  for la:=0 to Actors-1 do
  begin
    quadrant:=Act[la].quadrant;
    if pos(inttostr(quadrant),qmerk)=0 then //keinen Quadranten doppelt bearbeiten
    begin
      LinCou:=0; //Kollisionslinienzhler fr diesen Actor resetten
      qmerk:=qmerk+','+inttostr(quadrant); //Quadrant als schon bearbeitet merken
      if qua[quadrant].co>0 then		//nur behandeln, wenn auch Objekte da sind
      begin
        //Objekt im Quadrant
        for lm:=0 to qua[quadrant].co-1 do 		//Alle Objekte verarbeiten
        begin
          odx:=qua[quadrant].st[lm].dx+xori-act[ac].x; 	//Delay X des Objekts in der Welt (Verschiebung = X-Pos Objekt + Mitte Window + Position des Actors)
          ody:=qua[quadrant].st[lm].dy+yori-act[ac].y; 	//Delay Y
          odz:=qua[quadrant].st[lm].dz+zori-act[ac].z;	//Delay Z
          oof:=qua[quadrant].st[lm].ob; 		  	//Offset Objekt
          //Vorbereitung rotation betrifft gesamtes Objekt
          ux:=qua[quadrant].st[lm].umx; //Rotation um X
          uy:=qua[quadrant].st[lm].umy; //Rotation um Y
          uz:=qua[quadrant].st[lm].umz; //Rotation um Z
          if ux+uy+uz>0 then
          begin
            rotierung:=true;
            alpha:=ux*pi/180; beta:=uy*pi/180; gamma:=uz*pi/180; //Einmalige Berechnung frs ganze Objekt (Bogenmae der Winkel)
          end
          else
            rotierung:=false;
          //Polygone des Objekts
          for lp:=0 to Obj[oof].PolyCou-1 do
          begin
            if Obj[oof].Poly[lp].typ=0 then //nur Rahmenobjekt zulassen
            begin
              for ld:=0 to Obj[oof].Poly[lp].DrawCou-1 do
              begin
                  vertice:=Obj[oof].Poly[lp].draw[ld]; //Offset Vertice des Objekts
                  x:=Obj[oof].vert[vertice].x;
                  y:=Obj[oof].vert[vertice].y;
                  z:=Obj[oof].vert[vertice].z;
                  if rotierung then rotation;
                  {
                  if bShowCLines then
                  begin
                    bg.Canvas.Pen.Color:=Obj[oof].Poly[lp].color;
                    if ld=0 then bg.Canvas.moveto(trunc(odx+x),trunc(ody+y)) else
                      bg.Canvas.lineto(trunc(odx+x),trunc(ody+y));
                  end;
                  }
                  if ld>0 then //wenn es nicht der Startpunktz der Linie ist
                  begin
                    inc(LinCou);
                    sLin[quadrant].Lines[LinCou].Obj:=lm; //MatrixObjekt merken
                    sLin[quadrant].Lines[LinCou].Typ:=Obj[oof].typ; //Typ merken 
                    sLin[quadrant].Lines[LinCou].x1:=LastX;
                    sLin[quadrant].Lines[LinCou].y1:=LastY;
                    sLin[quadrant].Lines[LinCou].x2:=odx+x;
                    sLin[quadrant].Lines[LinCou].y2:=ody+y;
                  end;
                  LastX:=odx+x;
                  LastY:=ody+y;
              end;
            end;
          end;
        end;
      end;
      sLin[quadrant].LineCou:=LinCou; //Anzahl gemerkter Linien fr Kollisionscheck in diesem Quadranten festhalten
    end;
  end;
end;

//findet Kollision zwischen zwei Linien statt?
//bergabe
//	ax,ay,bx,by - Linie 1
//	cx,cy,dx,dy - Linie 2
//Ergebnis
//	Bool Result -> bei Kollision = true
//	kreuzpunkt_x und kreuzpunkt_y -> wo fand das crossing statt
function collision(ax,ay,bx,by,cx,cy,dx,dy:single):bool;
var
  rn,rd,sn:single;       //Hilfsvariablen der Funktion
begin
  rd:=(bx-ax)*(dy-cy)-(by-ay)*(dx-cx);
  If rd=0
    then result:=False
  else
    begin
      rn:=(ay-cy)*(dx-cx)-(ax-cx)*(dy-cy);
      sn:=(ay-cy)*(bx-ax)-(ax-cx)*(by-ay);
      kreuzpunkt_ab:=rn/rd;
      kreuzpunkt_cd:=sn/rd;
      kreuzpunkt_x:=ax+kreuzpunkt_ab*(bx-ax);
      kreuzpunkt_y:=ay+kreuzpunkt_ab*(by-ay);
      if (kreuzpunkt_ab<0) Or (kreuzpunkt_ab>1) Or (kreuzpunkt_cd<0) Or (kreuzpunkt_cd>1)
        Then  result:=false
      else result:=true;
    end;
end;

//Acotr zeichen
procedure drawActor;
var
  la,lm,lp,ld:integer;		//for "L"oop- ... Variablen
  oof:integer;			//Offset eines Objekts
  odx,ody,odz:single;		//Delaywert eines Objekts (wo ist es in der Welt?)
  vertice:integer; //Offset Vertice
  xv0,yv0,zv0:single; //Wert des Vertices
  LastX,LastY:single;
  LinCou:integer;
begin
  //Zeichnen
  for la:=0 to Actors-1 do
  begin
    LinCou:=0;
    oof:=Act[la].ob;
    ux:=act[la].umx; //Rotation um X
    uy:=act[la].umy; //Rotation um Y
    uz:=act[la].umz; //Rotation um Z
    alpha:=ux*pi/180; beta:=uy*pi/180; gamma:=uz*pi/180; //Einmalige Berechnung frs ganze Objekt (Bogenmae der Winkel)
    //Polygone des Objekts
    for lp:=0 to Obj[oof].PolyCou-1 do
    begin
      if Obj[oof].Poly[lp].typ=0 then //Rahmenobjekt?
      begin
        for ld:=0 to Obj[oof].Poly[lp].DrawCou-1 do
        begin
          with bg.Canvas do				//auf bg.canvas beziehen...
          begin
            vertice:=Obj[oof].Poly[lp].draw[ld]; //Offset Vertice des Objekts
            x:=Obj[oof].vert[vertice].x;  //x
            y:=Obj[oof].vert[vertice].y;  //y
            z:=Obj[oof].vert[vertice].z;  //z
            Rotation;
            if la=ac then //Actor in Bildschirmmitte zeichnen
              begin
                odx:=x+xori;
                ody:=y+yori;
                odz:=z+zori;
              end
            else  //sonst dahin wo er hin gehrt
              begin
                odx:=x+xori+act[la].x-act[AC].x;
                ody:=y+yori+act[la].y-act[AC].y;
                odz:=z+zori-act[la].z-act[AC].z;
              end;
            if bShowCLines then
            begin
              bg.Canvas.Pen.Color:=Obj[oof].Poly[lp].color;
              if ld=0 then moveto(trunc(odx),trunc(ody)) else
                lineto(trunc(odx),trunc(ody));
            end;
            if ld>0 then
            begin
              inc(LinCou);
              aLin[la].Lines[LinCou].Obj:=la;
              aLin[la].Lines[LinCou].x1:=LastX;
              aLin[la].Lines[LinCou].y1:=LastY;
              aLin[la].Lines[LinCou].x2:=odx;
              aLin[la].Lines[LinCou].y2:=ody;
            end;
            LastX:=odx;
            LastY:=ody;
          end;
        end;
      end;
    end;
    aLin[la].LineCou:=LinCou;
  end;
end;

//Grafik zeichnen
procedure drawGFX;
var
  ls,lp,ld:integer;
  oof:integer;			//Offset eines Objekts
  odx,ody,odz:single;		//Delaywert eines Objekts (wo ist es in der Welt?)
  vertice:integer; //Offset Vertice
  xv0,yv0,zv0:single; //Wert des Vertices
  LastX,LastY:single;
  LinCou:integer;
  Quadrant:integer;
  Objekt:integer;
begin
  Quadrant:=act[ac].quadrant;
  for ls:=0 to qua[Quadrant].co-1 do //Statisches Element im Quadranten
  begin
    ux:=qua[Quadrant].st[ls].umx; //Rotation um X
    uy:=qua[Quadrant].st[ls].umy; //Rotation um Y
    uz:=qua[Quadrant].st[ls].umz; //Rotation um Z
    alpha:=ux*pi/180; beta:=uy*pi/180; gamma:=uz*pi/180; //Einmalige Berechnung frs ganze Objekt (Bogenmae der Winkel)
    oof:=qua[Quadrant].st[ls].ob; //Objekt Offset
    //Polygone des Objekts
    for lp:=0 to Obj[oof].PolyCou-1 do
    begin
      if Obj[oof].Poly[lp].typ=9 then //Grafik-Polygon? Dann weiter...
      begin
        for ld:=0 to Obj[oof].Poly[lp].DrawCou-1 do
        begin
          with bg.Canvas do				//auf bg.canvas beziehen...
          begin
            vertice:=Obj[oof].Poly[lp].draw[ld]; //Offset Vertice des Objekts
            x:=Obj[oof].vert[vertice].x;  //x
            y:=Obj[oof].vert[vertice].y;  //y
            z:=Obj[oof].vert[vertice].z;  //z
            Rotation;
            odx:=x+xori+qua[Quadrant].st[ls].dx-act[ac].x;
            ody:=y+yori+qua[Quadrant].st[ls].dy-act[ac].y;
            odz:=z+zori+qua[Quadrant].st[ls].dz-act[ac].z;
            bg.Canvas.Pen.Color:=Obj[oof].Poly[lp].color;
            if ld=0 then moveto(trunc(odx),trunc(ody)) else
              lineto(trunc(odx),trunc(ody));
          end;
        end;
      end;
    end;
  end;
end;

procedure Bewegung;
var
  la:integer;
begin
  for la:=0 to actors-1 do
  begin
    //Aktuelle Werte speichern fr Rcksetzung nach einer eventuellen Kollision
    act[la].lx:=act[la].x;
    act[la].ly:=act[la].y;
    act[la].lz:=act[la].z;
    //Alte Werte merken		//Beovr der Actor eine neue Drehposition einnimmt, bitte die aktuelle Position merken
    act[la].lumx:=act[la].umx;
    act[la].lumy:=act[la].umy;
    act[la].lumz:=act[la].umz;
    //Auf Tasten reagieren in Bezug auf Actor-Steuerung
    if la=ac then //nur bei gesteuertem Actor drauf eingehen
    begin
      if taste[39] then act[ac].umz:=act[ac].umz+sync(90);	//Pfeil rechts (Actor dreht sich um die Z-Achse nach rechts)
      if taste[37] then act[ac].umz:=act[ac].umz-sync(90);	//Pfeil links
      if taste[38] then act[ac].sp:=act[ac].sp+sync(0.5);	//Pfeil hoch	(Vorwrts beschleunigen)
      if taste[40] then act[ac].sp:=act[ac].sp-sync(0.5);	//Pfeil runter	(rckwrts beschleunigen)
    end;
    //Rotation im Rahmen halten 0...359 Grad
    if act[la].umz>360 then act[la].umz:=act[la].umz-360;
    if act[la].umz<0 then act[la].umz:=act[la].umz+360;
    //Geschwindigkeit begrenzen des Actors
    if act[la].sp>2 then act[la].sp:=2;
    if act[la].sp<-1 then act[la].sp:=-1;
    //erst jetzt neue Positionen errechnen
    ux:=act[la].umx; //Rotation um X
    uy:=act[la].umy; //Rotation um Y
    uz:=act[la].umz; //Rotation um Z
    //Die neue Position des Actors ergibt sich aus dem Radius (der gleich der Geschwindigkeit ist) gedreht um den Winkel um die Z Achse
    //Da wo diese gedachte Linie von der Mitte des Actors aus betrachtet aufhrt, ist die neue Koordinate des Actors
    alpha:=ux*pi/180; beta:=uy*pi/180; gamma:=uz*pi/180; //Einmalige Berechnung frs ganze Objekt
    y:=act[la].sp; 	//Radius der Rotation = Speed des Actors
    x:=0;  z:=0;		//Spielen in der 2D Darstellung hier keine Rolle
    Rotation;
    act[la].x:=act[la].x+x;  act[la].y:=act[la].y+y;  act[la].z:=act[la].z+z; 	//Position um neue Werte erweitern
    act[la].qx:=act[la].qx+x;  act[la].qy:=act[la].qy+y;  act[la].qz:=act[la].qz+z; 	//Position um neue Werte erweitern
  end;
end;

procedure Kollision;
var
  la,lls,lla:integer;
  ax1,ay1,ax2,ay2,sx1,sy1,sx2,sy2:single;
  Quadrant:integer;
begin
  for la:=0 to Actors-1 do //alle Actoren durchgehen
  begin
    Quadrant:=act[la].quadrant;
    if aLin[la].LineCou>0 then
      for lla:=1 to aLin[la].LineCou do
      begin

        ax1:=aLin[la].Lines[lla].x1;
        ay1:=aLin[la].Lines[lla].y1;
        ax2:=aLin[la].Lines[lla].x2;
        ay2:=aLin[la].Lines[lla].y2;

        if sLin[Quadrant].LineCou>0 then
          for lls:=1 to sLin[Quadrant].LineCou do
          begin

            sx1:=sLin[Quadrant].Lines[lls].x1;
            sy1:=sLin[Quadrant].Lines[lls].y1;
            sx2:=sLin[Quadrant].Lines[lls].x2;
            sy2:=sLin[Quadrant].Lines[lls].y2;

            if collision(ax1,ay1,ax2,ay2,sx1,sy1,sx2,sy2) then
            begin
              bg.canvas.TextOut(trunc(kreuzpunkt_x-4),trunc(kreuzpunkt_y-4),'X');	//An Kollisionsstelle ein X printen

              //Letzte Position wiederherstellen...
              act[la].x:=act[la].lx;
              act[la].y:=act[la].ly;
              act[la].z:=act[la].lz;
              act[la].umx:=act[la].lumx;
              act[la].umy:=act[la].lumy;
              act[la].umz:=act[la].lumz;
              //und Speed zurcksetzen
              act[la].sp:=0;

            end;
          end;
      end;
  end;
end;


//Fensterfunktion - wird nur aufgerufen wenn Message vorhanden ist - z.B. Mausklick, Mausbewegung, ...
//The WindowProc function is an application-defined callback function that processes messages sent to a window.
function WindowProc(Window: HWND; AMessage,WParam,LParam: LongInt): LongInt; stdcall; export;
begin
  WindowProc:=0;
  case AMessage of        		//Nachrichten auswerten
    wm_keydown:
      begin
        taste[wparam]:=true;
        lastkey:=wparam;
      end;
    wm_keyup:
      begin
        taste[wparam]:=false;
      end;
    wm_LButtonDown:             	//linke Maustaste gedrueckt?
      begin
      //Beep(100,800);
      end;
    wm_Destroy:                 	//X-oben rechts geklickt zum schliessen der api?
      begin
        PostQuitMessage(0);
        exit;
      end;
  end;
//Standardverarbeitung fr alle anderen Botschaften (Fenster verschieben Grosse verndern...)
//The DefWindowProc function calls the default window procedure to provide default processing for any window messages that an application does not process. This function ensures that every message is processed. DefWindowProc is called with the same parameters received by the window procedure.
  WindowProc:=DefWindowProc(Window,AMessage,WParam,LParam);
end;

//----------------------------
//Programmablauf und Schleife
//----------------------------

begin 							//Startmarke

//Variablen setzen
  setzevars;

//Fensterklasse registrieren
  WindowClass.style:=cs_hRedraw or cs_vRedraw;
  WindowClass.lpfnWndProc:=@WindowProc;
  WindowClass.cbCLsExtra:=0;
  WindowClass.cbWNDExtra:=0;
  WindowClass.hInstance:=HInstance;
  WindowClass.hIcon:=loadIcon(0,idi_Application);
  WindowClass.hCursor:=loadcursor(0,idc_Arrow);
  WindowClass.hbrBackground:=HBrush(Color_window);
  WindowClass.lpszMenuName:=nil;
  WindowClass.lpszClassName:=AppName;

  if RegisterClass(WindowClass)=0 then exit; //Wenn Registrierung i.o. dann weiter sonst ende

//Fenster erzeugen
  winwidth:=640;
  winheight:=400;
  hWindow:=createWindow(Appname,'APIMATRIX',ws_Overlappedwindow,
           cw_UseDefault, cw_UseDefault,winwidth,winheight,
           0,0,Hinstance,nil);

//Fenster anzeigen
  if hWindow<>09 then
    begin
    ShowWindow(hWindow,CmdShow); //The ShowWindow function sets the specified window's show state.
    UpdateWindow(hWindow); //The UpdateWindow function updates the client area of the specified window by sending a WM_PAINT message to the window if the window's update region is not empty. The function sends a WM_PAINT message directly to the window procedure of the specified window, bypassing the application queue. If the update region is empty, no message is sent.
    end
  else
    exit;

//Fensterkontext fr Graphicausgabe holen
  canvas:=TCanvas.Create;
  dc:=GetWindowDC(HWindow); //Gertekontext des Fensters holen
  canvas.Handle:=dc; //Zeichenobjekt zugewiesen

//zeichen Hintergrundbitmap machen
  bg:=TBitmap.Create;
  bg.height:=winheight;
  bg.width:=winwidth;

//Message Loop - Hauptschleife
  while running do
  begin
    sysmes:=PeekMessage(AMessage,0,0,0,PM_Remove); //aktuelle Botschaften vom System abfangen ohne den Prosses anzuhalten
    if sysmes then //wenn Message, dann hier weiter machen
    begin
      if Amessage.message=WM_QUIT then
        begin
          running:=false; //Programm soll beendet werden
        end
        else //ansonsten normale Windows Messages weiter verarbeiten
        begin
          TranslateMessage(AMessage); //The TranslateMessage function translates virtual-key messages into character messages. The character messages are posted to the calling thread's message queue, to be read the next time the thread calls the GetMessage or PeekMessage function.
          DispatchMessage(AMessage); //The DispatchMessage function dispatches a message to a window procedure. It is typically used to dispatch a message retrieved by the GetMessage function.
        end;
    end;
      sleep(5);			    //fr bessere Integration der Anwendung im System
    //Grafikprozess
      bg.canvas.fillrect(MyRect); 		//Screen leeren
      bewegung; 		    //neue Position der Welt um den Actor ausrechnen
      drawStatic;				//Hindernisse zeichnen
      drawActor;				//Actor zeichnen
      Kollision;        //Vergleiche aufgezeichnete Linien auf Kollision
      screentext;  			//Info auf Screen
      drawGFX;          //nur das zeichnen was eigentlich gezeichnet werden soll
      canvas.copyrect(myrect,bg.canvas,myrect); //Swap gfx - das im Hintergrund gezeichnete sichtbar machen
    //weiter
      zeitmessung; 			//Frames per Second ermitteln
      tastatur; 				//Tastaturabfrage wird kontinuierlich aufgerufen
  end;

//Programmende
  bg.free; 					//Zeichenbitmap freigeben
  releaseDC(0,dc); 				//Gertekontext fr Grafikausgabe auflsen
  Halt(AMessage.wParam);  			//Die Prozedur Halt lst einen Programmabbruch aus und gibt die Steuerung an das Betriebssystem zurck
end. 						//Endmarke




